﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace test_header
{
    public partial class Form1 : Form
    {
        DefaultSheetDataModel dataModel = new DefaultSheetDataModel();

        public Form1()
        {
            InitializeComponent();
        }

        void Fill_Table()
        {
            DataTable data_table = new DataTable("name");
            data_table.Columns.Add("time_now");
            data_table.Columns.Add("connect_time");
            data_table.Columns.Add("time_diff");

            data_table.Columns["time_now"].DataType = typeof(DateTime);
            data_table.Columns["connect_time"].DataType = typeof(DateTime);

            XmlReader reader = XmlReader.Create(new StringReader(File.ReadAllText("datasource.xml")));
            XmlDocument doc = new XmlDocument();
            doc.Load(reader);
            reader.Close();

            XmlNodeList items_list = doc.SelectNodes("/items_list/item");

            for (int i = 0; i < items_list.Count; i++)
            {
                XmlNode xn = items_list.Item(i);

                DateTime time_now = DateTime.Now;

                DateTime? connect_time = null; 
                if (xn["connect_time"] != null)
                {
                    DateTime dt;
                    DateTime.TryParse(xn["connect_time"].InnerText, out dt);
                    connect_time = dt;
                }

                string time_diff = "---";
                data_table.Rows.Add(time_now, connect_time, time_diff);
            }
            DataSet data_set = new DataSet();
            data_set.Tables.Add(data_table);
           
            dataModel.DataSource = data_set;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Fill_Table();
            fpSpread1.Sheets[0].Models.Data = dataModel;
        }

       
        private void button3_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Columns[2].Formula = textBox1.Text;
        }

        private void fpSpread1_CellClick(object sender, CellClickEventArgs e)
        {
            int i = e.Row;
            int j = e.Column;
            if (j == 2)
                MessageBox.Show(fpSpread1.ActiveSheet.Columns[2].Formula);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int i = Convert.ToInt32(textBox2.Text)-1;
            DateTime dt1;
            DateTime dt2;
            DateTime.TryParse(fpSpread1.ActiveSheet.Cells[i, 0].Value.ToString(), out dt1);
            DateTime.TryParse(fpSpread1.ActiveSheet.Cells[i, 1].Value.ToString(), out dt2);
            textBox3.Text = (dt1-dt2).Days.ToString();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Columns[2].Formula = "false";

            //fpSpread1.ActiveSheet.Columns[2].Formula = "";
            //fpSpread1.Refresh();
        }
    }
}
